/*
 * CLCL
 *
 * Ini.h
 *
 * Copyright (C) 1996-2003 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_INI_H
#define _INC_INI_H

/* Include Files */

#include "Menu.h"
#include "Format.h"
#include "Filter.h"
#include "Window.h"
#include "SendKey.h"
#include "Tool.h"

/* Define */
#define ACTION_POPUPMEMU				0
#define ACTION_VIEWER					1
#define ACTION_OPTION					2
#define ACTION_CLIPBOARD_WATCH			3
#define ACTION_EXIT						4

#define ACTION_TYPE_HOTKEY				0
#define ACTION_TYPE_CTRL_CTRL			1
#define ACTION_TYPE_SHIFT_SHIFT			2
#define ACTION_TYPE_ALT_ALT				3
#define ACTION_TYPE_TRAY_LEFT			4
#define ACTION_TYPE_TRAY_LEFT_DBLCLK	5
#define ACTION_TYPE_TRAY_RIGHT			6
#define ACTION_TYPE_TRAY_RIGHT_DBLCLK	7

#define OPTION_SHOW_HISTORY				TEXT("0")
#define OPTION_SHOW_MENU				TEXT("1")
#define OPTION_SHOW_VIEWER				TEXT("2")
#define OPTION_SHOW_ACTION				TEXT("3")
#define OPTION_SHOW_FORMAT				TEXT("4")
#define OPTION_SHOW_FILTER				TEXT("5")
#define OPTION_SHOW_WINDOW				TEXT("6")
#define OPTION_SHOW_SENDKEY				TEXT("7")
#define OPTION_SHOW_TOOL				TEXT("8")

/* Struct */
// color info
typedef struct _COLOR_INFO {
	TCHAR *color_str;
	int color;
} COLOR_INFO;

// action info
typedef struct _ACTION_INFO {
	int action;							// ACTION_
	int type;							// ACTION_TYPE_

	int enable;							// 0- 1-L
	int caret;							// Caretʒuɕ\

	// hot key
	int id;
	UINT modifiers;
	UINT virtkey;
	int paste;

	struct _MENU_INFO *menu_info;
	int menu_cnt;
} ACTION_INFO;

// option
typedef struct _OPTION_INFO {
	// main
	int main_clipboard_watch;			// Nbv{[hĎ
	int main_clipboard_rechain_minute;	// Nbv{[hĊĎ
	int main_show_trayicon;				// ^XNgCɃACR\
	int main_show_viewer;				// NɃr[A\

	// data
	TCHAR *data_date_format;
	TCHAR *data_time_format;

	// history
	int history_add_interval;			// ɒǉ܂ł̃C^[o
	int history_save;					// Iɗۑ
	int history_always_save;			// ύXΏɕۑ
	int history_delete;					// Nbv{[hɑƗ폜
	int history_max;					// 
	int history_overlap_check;			// ̏d`FbN 0-`FbNȂ 1-ŋ߂̂P̂݃`FbN 2-SĂ̗`FbN
	int history_ignore_regist_item;		// o^ACeNbv{[hɑɗɓȂ

	// menu
	TCHAR *menu_text_format;			// j[^Cg̕\`
	int menu_intact_item_title;			// ACe^Cgꍇ͂̂܂ܕ\
	int menu_text_margin_left;			// eLXg̍}[W
	int menu_text_margin_right;			// eLXg̉E}[W
	int menu_text_margin_y;				// eLXg̏㉺}[W
	int menu_separator_height;			// ؂̍
	int menu_separator_margin_left;		// ؂̍}[W
	int menu_separator_margin_right;	// ؂̉E}[W
	int menu_max_width;					// j[̍ő啝
	int menu_break;						// ʂ͂ݏoꍇ̐܂Ԃ
	int menu_show_icon;					// ACR\
	int menu_icon_size;					// ACR̃TCY
	int menu_icon_margin;				// ACR̃}[W
	int menu_show_bitmap;				// rbg}bv\
	int menu_bitmap_width;				// rbg}bv̉
	int menu_bitmap_height;				// rbg}bv̏c
	int menu_show_tooltip;				// c[`bv\
	int menu_show_hotkey;				// zbgL[\
	int menu_show_tool_menu;			// c[j[\
#ifdef MENU_LAYERER
	int menu_alpha;						// x
#endif
	TCHAR *menu_font_name;				// j[̃tHg
	int menu_font_size;
	int menu_font_weight;
	int menu_font_italic;
	int menu_font_charset;
#ifdef MENU_COLOR
	COLOR_INFO menu_color_back;			// j[̐F
	COLOR_INFO menu_color_text;
	COLOR_INFO menu_color_highlight;
	COLOR_INFO menu_color_highlighttext;
	COLOR_INFO menu_color_3d_shadow;
	COLOR_INFO menu_color_3d_highlight;
#endif

	// tooltip
	int tooltip_show_delay;				// c[`bv\܂ł̑҂(~b)
	int tooltip_tab_length;				// c[`bṽ^u
	int tooltip_margin_x;				// c[`bvɕ\镶̉}[W
	int tooltip_margin_y;				// c[`bvɕ\镶̏c}[W
	TCHAR *tooltip_font_name;			// c[`bṽtHg
	int tooltip_font_size;
	int tooltip_font_weight;
	int tooltip_font_italic;
	int tooltip_font_charset;
#ifdef TOOLTIP_COLOR
	COLOR_INFO tooltip_color_back;		// c[`bv̐F
	COLOR_INFO tooltip_color_text;
#endif

	// action
	int action_double_press_time;		// CTRL or Shift or Alt1ڂ2ڂ̃L[ԂɌo߂鎞(~b)
	int action_show_hotkey_error;		// zbgL[̃G[\
	ACTION_INFO *action_info;
	int action_cnt;

	// format
	FORMAT_INFO *format_info;
	int format_cnt;

	// filter
	int filter_all_action;
	FILTER_INFO *filter_info;
	int filter_cnt;

	// window filter
	WINDOW_FILTER_INFO *window_filter_info;
	int window_filter_cnt;

	// send key
	UINT def_copy_modifiers;
	UINT def_copy_virtkey;
	int def_copy_wait;					// Rs[܂ł̑҂

	UINT def_paste_modifiers;
	UINT def_paste_virtkey;
	int def_paste_wait;					// \t܂ł̑҂

	SENDKEY_INFO *sendkey_info;
	int sendkey_cnt;

	// tool
	int tool_valid_interval;			// 상j[̑IŃc[LȎ
	TOOL_INFO *tool_info;
	int tool_cnt;

	// viewer
	int viewer_toggle;					// \gO
	int viewer_show_bin;				// ɃoCi\
	int viewer_show_toolbar;
	int viewer_show_statusbar;
	int viewer_delete_confirm;			// 폜mF 0-Ȃ 1-
	RECT viewer_rect;
	int viewer_sep_size;

	// treeview
	int tree_show_format;				// c[Ɍ`\
	TCHAR *tree_root_order;				// [g̕\ƕя 0-clip 1-history 2-regist
	int tree_clip_expand;				// Nbv{[hWJ
	int tree_history_expand;			// WJ
	int tree_regist_expand;				// o^ACeWJ
	int tree_folder_expand;				// tH_WJ
	TCHAR *tree_font_name;
	int tree_font_size;
	int tree_font_weight;
	int tree_font_italic;
	int tree_font_charset;

	// listview
	int list_default_action;			// ftHg 0-\ 1-Nbv{[hɑ 2-Otĕۑ
	int list_column_data;
	int list_column_size;
	int list_column_date;
	int list_column_window;
	TCHAR *list_font_name;
	int list_font_size;
	int list_font_weight;
	int list_font_italic;
	int list_font_charset;

	// bin view
	int bin_lock;
	TCHAR *bin_font_name;
	int bin_font_size;
	int bin_font_weight;
	int bin_font_italic;
	int bin_font_charset;

	// text format
	int fmt_txt_menu_tooltip_size;		// c[`bvɕ\镶
	int fmt_txt_viewer_word_wrap;		// E[Ő܂Ԃ
	int fmt_txt_tab_size;				// TABTCY
	TCHAR *fmt_txt_font_name;
	int fmt_txt_font_size;
	int fmt_txt_font_weight;
	int fmt_txt_font_italic;
	int fmt_txt_font_charset;

	// bitmap format
	int fmt_bmp_stretch_mode;			// 摜EBhȆ傫ɍ킹ĕ\

	// file format
	int fmt_file_column_name;
	int fmt_file_column_folder;
	int fmt_file_column_type;
	TCHAR *fmt_file_font_name;
	int fmt_file_font_size;
	int fmt_file_font_weight;
	int fmt_file_font_italic;
	int fmt_file_font_charset;
} OPTION_INFO;

/* Function Prototypes */
BOOL ini_get_option(TCHAR *err_str);
BOOL ini_put_option(void);
void ini_free_format_name(FORMAT_NAME *fn, const int fn_cnt);
void ini_free_menu(MENU_INFO *mi, const int mcnt);
BOOL ini_free(void);

#endif
/* End of source */
